---
title: "Create a new branch - Xata"
description: "Creates a new branch within the specified project. Branches can be created from scratch or derived from an existing parent branch."
source: "https://xata.io/docs/api-reference/branches/create-a-new-branch"
---

Skip to main content

POST

/

organizations

/

{organizationID}

/

projects

/

{projectID}

/

branches

Create a new branch

```
curl --request POST
  --url https://api.xata.tech/organizations/{organizationID}/projects/{projectID}/branches
  --header 'Authorization: Bearer <token>'
  --header 'Content-Type: application/json'
  --data '
{
  "mode": "inherit",
  "parentID": "<string>",
  "name": "<string>",
  "description": "<string>",
  "backupConfiguration": {
    "retentionPeriod": 2,
    "backupTime": "<string>"
  }
}
'
```

```
import requests

url = "https://api.xata.tech/organizations/{organizationID}/projects/{projectID}/branches"

payload = {
    "mode": "inherit",
    "parentID": "<string>",
    "name": "<string>",
    "description": "<string>",
    "backupConfiguration": {
        "retentionPeriod": 2,
        "backupTime": "<string>"
    }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

```
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    mode: 'inherit',
    parentID: '<string>',
    name: '<string>',
    description: '<string>',
    backupConfiguration: {retentionPeriod: 2, backupTime: '<string>'}
  })
};

fetch('https://api.xata.tech/organizations/{organizationID}/projects/{projectID}/branches', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

```


```

```
{
  "id": "<string>",
  "name": "<string>",
  "createdAt": "2023-11-07T05:31:56Z",
  "updatedAt": "2023-11-07T05:31:56Z",
  "region": "<string>",
  "publicAccess": true,
  "description": "<string>",
  "parentID": "<string>",
  "connectionString": "<string>"
}
```

```
{
  "message": "<string>",
  "id": "<string>"
}
```

```
{
  "message": "<string>",
  "id": "<string>"
}
```

```
{
  "message": "<string>",
  "id": "<string>"
}
```

```
{
  "message": "<string>",
  "id": "<string>"
}
```

#### Authorizations

​

Authorization

string

header

required

The access token received from the authorization server in the OAuth 2.0 flow.

#### Path Parameters

​

organizationID

string

required

Unique identifier of the organization containing the project

Pattern: `[a-zA-Z0-9_-~:]+`

​

projectID

string

required

Unique identifier of the project to create the branch in

#### Body

application/json

- Option 1
- Option 2

Details required when creating a new branch

​

mode

enum\<string>

required

The mode used to discriminate between types of branches.

Available options:

`inherit`

​

parentID

string

required

If present, the branch will inherit the parent branch configuration and data

​

name

string

required

Human-readable name for the new branch

​

description

string

Optional description for the branch purpose or contents (max 50 characters)

Maximum string length: `50`

Pattern: `^[a-zA-Z0-9]+[a-zA-Z0-9- ]*$`

​

scaleToZero

object

Configuration for scaling branches to zero when not in use

Show child attributes

​

backupConfiguration

object

Details about the branch continuous backup configuration

Show child attributes

#### Response

Branch successfully created

Basic metadata about a branch, used in response to create/update operations

​

id

string

required

Unique identifier for the branch

​

name

string

required

Human-readable name of the branch

​

createdAt

string\<date-time>

required

Timestamp when the branch was created

​

updatedAt

string\<date-time>

required

Timestamp when the branch was last updated

​

region

string

required

Geographic region where the branch is deployed

​

publicAccess

boolean

required

Whether the branch allows public access without authentication

​

description

string

Optional description of the branch purpose or contents

​

parentID

string | null

Identifier of the parent branch if this is a derived branch, null otherwise

​

connectionString

string | null

Database connection string for accessing this branch

Was this page helpful?

[Previous](/docs/api-reference/branches/list-all-branches)

[Get branch details](/docs/api-reference/branches/get-branch-details)

[Next](/docs/api-reference/branches/get-branch-details)
